# -*- coding: utf-8 -*-
# ----------------------------------------------------------------------------#
#  Copyright © 2015-2016 VMware, Inc. All Rights Reserved.                    #
#                                                                             #
#  Licensed under the BSD 2-Clause License (the “License”); you may not use   #
#  this file except in compliance with the License.                           #
#                                                                             #
#  The BSD 2-Clause License                                                   #
#                                                                             #
#  Redistribution and use in source and binary forms, with or without         #
#  modification, are permitted provided that the following conditions are met:#
#                                                                             #
#  - Redistributions of source code must retain the above copyright notice,   #
#      this list of conditions and the following disclaimer.                  #
#                                                                             #
#  - Redistributions in binary form must reproduce the above copyright        #
#      notice, this list of conditions and the following disclaimer in the    #
#      documentation and/or other materials provided with the distribution.   #
#                                                                             #
#  THIS SOFTWARE IS PROVIDED BY THE COPYRIGHT HOLDERS AND CONTRIBUTORS "AS IS"#
#  AND ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE  #
#  IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE #
#  ARE DISCLAIMED. IN NO EVENT SHALL THE COPYRIGHT HOLDER OR CONTRIBUTORS BE  #
#  LIABLE FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR        #
#  CONSEQUENTIAL DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF       #
#  SUBSTITUTE GOODS OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS   #
#  INTERRUPTION) HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN    #
#  CONTRACT, STRICT LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE)    #
#  ARISING IN ANY WAY OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF     #
#  THE POSSIBILITY OF SUCH DAMAGE.                                            #
# ----------------------------------------------------------------------------#

from liota.dcc.helix_protocol import getUTCmillis
from liota.utilities.utility import get_linux_version, systemUUID

from gateway import Gateway
from handlers import ObjectConfig


class Dk300(Gateway):
    """ Basic implementation of DK300 Object

    """

    def __init__(self, label):
        Gateway.__init__(self, 'Intel', 'Galileo-DK300', get_linux_version(), systemUUID().get_uuid(label), label, None, None, None, "HelixGateway")

    def _configure_pins(self):
        pass

    def _initialize_gateway(self):
        # Initialize the Gateway Object
        return ObjectConfig(identifier=self.identifier, name=self.res_name, res_kind=self.res_kind, template=self.res_kind, uuid=self.res_uuid , property_key_value_map=self.property_key_value_map)

    def _report_data(self, msg_id, statkey, timestamps, values):
        # Post data onto cloud_provider solution
        return Gateway._report_data(self, msg_id, statkey, timestamps, values)

    def _create_relationship(self, msg_id, child):
        pass

    def set_properties(self, key, value):
        Gateway.set_properties(self, key, value)